//+------------------------------------------------------------------+
//|                                        ManualOrderManager_v6.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double LotSize=0.3;
extern bool OpenHigh=true;
extern bool OpenLow=true;
extern int Shift=1;
extern int magicnumber=0;

extern int SL = 10;
extern int TP = 10;
//extern int BreakEvenAt = 25;
//extern int TrailingStop = 25;
extern color LongTPColour = Lime;
extern int LongTPWidth = 1;
extern int LongTPStyle = 3;
extern color LongSLColour = Red;
extern int LongSLWidth = 1;
extern int LongSLStyle = 3;
extern color ShortTPColour = Lime;
extern int ShortTPWidth = 1;
extern int ShortTPStyle = 3;
extern color ShortSLColour = Red;
extern int ShortSLWidth = 1;
extern int ShortSLStyle = 3;
extern bool CloseHalfLots=false;


extern bool AlarmStopLoss=true;
extern bool AlarmTrailStop=true;
extern bool AlarmBreakeven=true;
extern bool AlarmHalfTP=false;
extern bool AlarmTP=true;


double Lots=0;
double sl,tp;
int os=0;
int adj, TrailingStep = 1;
int OrdersHalfClosedTicket[500];
double OrdersHalfClosedLots[500];
int PRESLIPPAGE=80,SLIPPAGE=0;
double RealPoint=0;
int orderscontrol=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits == 3 || Digits == 5){adj = 10;}else {adj = 1;}
   
   Lots=LotSize;

   if (Digits==3 || Digits==5)
   {
      RealPoint=Point*10;
      SLIPPAGE=PRESLIPPAGE*10;
   }
   else
   {
      RealPoint=Point;
      SLIPPAGE=PRESLIPPAGE;
   }
   
   InitializeBuffers();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("SL");
   ObjectDelete("TP");
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
      if(Lots<MarketInfo(Symbol(),MODE_MINLOT))
      {
         Alert("Number of Lots is not permitted.Please Change de Lots value in the Expert Properties page.");
         Sleep(60000);
         return(0);
      }
      
      if(orderscontrol==0)
         SendOrders();
      
      CO();
      
      if(CloseHalfLots==true)
      {
         CHLO();
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+

void SendOrders()
{  
   if(TotalOrders()>0)
      return(0);
   
   int LongType=0,ShortType=0;
   if(OpenHigh==false && OpenLow==false)
      return(0);
      
   if(OpenHigh==true)
   {
      if(Ask<High[Shift]+RealPoint)
         LongType=OP_BUYSTOP;
      else
         LongType=OP_BUYLIMIT;
      
      while(IsTradeContextBusy()==false)
      {
         RefreshRates();
         os=OrderSend(Symbol(),LongType,Lots,High[Shift]+RealPoint,SLIPPAGE,0,0,NULL,magicnumber,0,Blue);
         break;
      }
      if(os==-1)
      {
         Alert("Error:"+GetLastError());
      }
      orderscontrol=1;
   }
   
   if(OpenLow==true)
   {
      if(Bid<Low[Shift]-RealPoint)
         ShortType=OP_SELLLIMIT;
      else
         ShortType=OP_SELLSTOP;
      
      while(IsTradeContextBusy()==false)
      {
         RefreshRates();
         os=OrderSend(Symbol(),ShortType,Lots,Low[Shift]-RealPoint,SLIPPAGE,0,0,NULL,magicnumber,0,Red);
         break;
      }
      if(os==-1)
      {
         Alert("Error:"+GetLastError());
      }
      orderscontrol=1;
   }
   
   
   
   
   return(0);
}


int TotalOrders()
{
   int orders=OrdersTotal();
   int totalord=0;
   
   if(orders==0)
   {
      return(0);
   }
   else
   {
      for(;orders>=0;orders--)
      {
         RefreshRates();
         OrderSelect(orders,SELECT_BY_POS);
         if(OrderMagicNumber()==magicnumber && OrderSymbol()==Symbol())
         {
            totalord++;
         }
      }
   }
   return(totalord);
}



void InitializeBuffers()
{
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);

      if(OrderMagicNumber() == 0 && OrderSymbol() == Symbol())
      {
         OrdersHalfClosedTicket[f]=OrderTicket();
         OrdersHalfClosedLots[f]=OrderLots();
      }
   }  
   
}
int CO()// manage orders
{
   int c = 0;
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);

      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         c++;
         if( OrderType() == OP_BUY )
         {
            sl = OrderOpenPrice()-fx(SL);
            tp = OrderOpenPrice()+fx(TP);
            
            if(gl("SL"+OrderTicket())>0)sl = gl("SL"+OrderTicket());
            if(gl("TP"+OrderTicket())>0)tp = gl("TP"+OrderTicket());

            //if(BreakEvenAt > 0 && Bid - OrderOpenPrice() > fx(BreakEvenAt) && sl < OrderOpenPrice())
            {
               sl = OrderOpenPrice();
               if(AlarmBreakeven)
                  PlaySound("Breakeven.wav");
            }
            //if(TrailingStop > 0 && Bid - OrderOpenPrice()> fx(TrailingStop) && sl < Bid -(fx(TrailingStop)+fx(TrailingStep)-fx(1)) ) 
            {
               //sl = Bid-fx(TrailingStop);
               tp = sl+fx(SL+TP); 
               if(AlarmTrailStop)
                  PlaySound("wait.wav");
            }
            
            SetLine("SL"+OrderTicket(),sl,LongSLColour,LongSLWidth,LongSLStyle);
            ObjectSetText("SL"+OrderTicket(),"SL"+OrderTicket());
            SetLine("TP"+OrderTicket(),tp,LongTPColour,LongTPWidth,LongTPStyle);
            ObjectSetText("TP"+OrderTicket(),"TP"+OrderTicket());

            if(Bid >= tp || Bid <= sl)OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
            if(Bid>=tp && AlarmTP)
               PlaySound("mtp1.wav");
            if(Bid<=sl && AlarmStopLoss)
               PlaySound("Alarm.wav");          
         }
         if( OrderType() == OP_SELL )
         {
            sl = OrderOpenPrice()+fx(SL);
            tp = OrderOpenPrice()-fx(TP);
            
            if(gl("SL"+OrderTicket())>0)sl = gl("SL"+OrderTicket());
            if(gl("TP"+OrderTicket())>0)tp = gl("TP"+OrderTicket());


            //if(BreakEvenAt > 0 && OrderOpenPrice()-Ask > fx(BreakEvenAt) && sl > OrderOpenPrice())
            {
               sl = OrderOpenPrice();
               if(AlarmBreakeven)
                  PlaySound("Breakeven.wav");
            }
            
            //if(TrailingStop > 0 && OrderOpenPrice()-Ask > fx(TrailingStop) && sl > Ask+(fx(TrailingStop)+fx(TrailingStep)-fx(1)) ) 
            {
              //sl = Ask+fx(TrailingStop);
              tp = sl-fx(SL+TP);  
              if(AlarmTrailStop)
                  PlaySound("wait.wav");
            }

            SetLine("SL"+OrderTicket(),sl,ShortSLColour,ShortSLWidth,ShortSLStyle);
            ObjectSetText("SL"+OrderTicket(),"SL"+OrderTicket());
            SetLine("TP"+OrderTicket(),tp,ShortTPColour,ShortTPWidth,ShortTPStyle);
            ObjectSetText("TP"+OrderTicket(),"TP"+OrderTicket());

            if(Ask <= tp || Ask >= sl)OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
            
            if(Ask<=tp && AlarmTP)
               PlaySound("Alert.wav");
            if(Ask>=sl && AlarmStopLoss)
               PlaySound("Alarm.wav"); 
         }
      }
   }  
   
   for(int z = 0; z < OrdersHistoryTotal();z++)
   {
      OrderSelect(z,SELECT_BY_POS,MODE_HISTORY);
      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         if(gl("SL"+OrderTicket())>0)ObjectDelete("SL"+OrderTicket());
         if(gl("TP"+OrderTicket())>0)ObjectDelete("TP"+OrderTicket());
      } 
   }

   return(c);    
}


void CHLO()
{     
   for(int f = 0; f < OrdersTotal();f++)
   {
      OrderSelect(f,SELECT_BY_POS,MODE_TRADES);
      
      if(OrderHalfClosed(OrderTicket(),OrderLots())) continue;

      if(OrderMagicNumber() == magicnumber && OrderSymbol() == Symbol())
      {
         if( OrderType() == OP_BUY )
         {
            //tp = OrderOpenPrice()+fx(TP)/2;
            if(Bid >= tp && OrderLots()>=2*MarketInfo(Symbol(),MODE_MINLOT))
            {
               OrderClose(OrderTicket(),OrderLots()/2,Bid,0,CLR_NONE);
               OrdersHalfClosedTicket[f]=OrderTicket();
               if(AlarmHalfTP)
                  PlaySound("HalfProfit.wav");
            }
         }
         if( OrderType() == OP_SELL )
         {
            //tp = OrderOpenPrice()-fx(TP)/2;
            if(Ask <= tp && OrderLots()>=2*MarketInfo(Symbol(),MODE_MINLOT))
            {
               OrderClose(OrderTicket(),OrderLots()/2,Ask,0,CLR_NONE);
               OrdersHalfClosedTicket[f]=OrderTicket();
               if(AlarmHalfTP)
                  PlaySound("HalfProfit.wav");
            }
         }
      }
   }  
   return(0);    
}

bool OrderHalfClosed(int ticket, double lots)
{
   for(int f = 0; f < OrdersTotal();f++)
   {
      if(OrdersHalfClosedTicket[f]==ticket && OrdersHalfClosedLots[f]==lots)
      {
         return(false);
      }
   }
   return(true); 
}



//+------------------------------------------------------------------+
void SetLine(string ln, double lp, color lc, int lw, int ls)
{
   if(ObjectFind(ln) < 0)
   {
      ObjectCreate(ln,OBJ_HLINE,0,0,lp);
   }
   else
   {
      ObjectSet(ln,OBJPROP_PRICE1,lp);
      ObjectSet(ln,OBJPROP_COLOR,lc);
      ObjectSet(ln,OBJPROP_WIDTH,lw);
      ObjectSet(ln,OBJPROP_STYLE,ls);
   }
}
//+------------------------------------------------------------------+
double gl(string nnn)// return point value
{
   return(ObjectGet(nnn,OBJPROP_PRICE1));
}
//+------------------------------------------------------------------+
double fx(int nnn)// return point value
{
   return((nnn*adj)*Point);
}
//+------------------------------------------------------------------+